# coding: utf-8


"""
IGNORE:
    Nutanix Flow Management APIs

    Manage Network Security Policy configuration of Nutanix clusters.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_microseg_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_microseg_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_microseg_py_client.models.microseg.v4.config.AdInfo import AdInfo  # noqa: F401,E501

class CategoryMapping(ExternalizableAbstractModel):

    """

    :param name: (:attr:`name`) Name of Category Mapping.
    :type name: required
     max=1000 chars
    
    :param category_name: (:attr:`category_name`) The name for the category that this mapping is for.
    :type category_name: required
     max=200 chars
    
    :param category_value: (:attr:`category_value`) The value for the category that this mapping is for.
    :type category_value: required
     max=1000 chars
    
    :param ad_info: (:attr:`ad_info`) 
    :type ad_info: required
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'name': 'str',
        'category_name': 'str',
        'category_value': 'str',
        'ad_info': 'microseg.v4.config.AdInfo',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'category_name': 'categoryName',
        'category_value': 'categoryValue',
        'ad_info': 'adInfo',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, category_name=None, category_value=None, ad_info=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__category_name = None
        self.__category_value = None
        self.__ad_info = None
        self.discriminator = None
        self.__name = name
        self.__category_name = category_name
        self.__category_value = category_value
        self.__ad_info = ad_info

    def _initialize_object_type(self):
        return 'microseg.v4.config.CategoryMapping'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def name(self):
        """
        Name of Category Mapping.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if name is not None and len(name) > 1000:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `1000`")  # noqa: E501

        self.__name = name

    @property
    def category_name(self):
        """
        The name for the category that this mapping is for.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__category_name

    @category_name.setter
    def category_name(self, category_name):
        if category_name is None:
            raise ValueError("Invalid value for `category_name`, must not be `None`")  # noqa: E501
        if category_name is not None and len(category_name) > 200:
            raise ValueError("Invalid value for `category_name`, length must be less than or equal to `200`")  # noqa: E501

        self.__category_name = category_name

    @property
    def category_value(self):
        """
        The value for the category that this mapping is for.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__category_value

    @category_value.setter
    def category_value(self, category_value):
        if category_value is None:
            raise ValueError("Invalid value for `category_value`, must not be `None`")  # noqa: E501
        if category_value is not None and len(category_value) > 1000:
            raise ValueError("Invalid value for `category_value`, length must be less than or equal to `1000`")  # noqa: E501

        self.__category_value = category_value

    @property
    def ad_info(self):
        """
        

        :type:
            :class:`~ntnx_microseg_py_client.models.microseg.v4.config.AdInfo`
        """  # noqa: E501
        return self.__ad_info

    @ad_info.setter
    def ad_info(self, ad_info):
        if ad_info is None:
            raise ValueError("Invalid value for `ad_info`, must not be `None`")  # noqa: E501

        self.__ad_info = ad_info

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(CategoryMapping, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CategoryMapping):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

