# coding: utf-8


"""
IGNORE:
    Nutanix Flow Management APIs

    Manage Network Security Policy configuration of Nutanix clusters.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_microseg_py_client.models.microseg.v4.config.MatchEntity import MatchEntity  # noqa: F401,E501
from ntnx_microseg_py_client.models.microseg.v4.config.MatchField import MatchField  # noqa: F401,E501
from ntnx_microseg_py_client.models.microseg.v4.config.MatchType import MatchType  # noqa: F401,E501

class MatchingCriteria(object):

    """The matching criteria used to determine whether an entity will be categorized by identity categorization. If match type is ALL, all the entities will be categorized.

    :param match_entity: (:attr:`match_entity`) 
    :type match_entity: required
    
    
    :param match_field: (:attr:`match_field`) 
    :type match_field: required
    
    
    :param match_type: (:attr:`match_type`) 
    :type match_type: required
    
    
    :param criteria: (:attr:`criteria`) The criteria to use for matching entities to be categorized. Note that depending on the match type, the usage of this value may differ.
    :type criteria: 
     max=200 chars
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'match_entity': 'microseg.v4.config.MatchEntity',
        'match_field': 'microseg.v4.config.MatchField',
        'match_type': 'microseg.v4.config.MatchType',
        'criteria': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'match_entity': 'matchEntity',
        'match_field': 'matchField',
        'match_type': 'matchType',
        'criteria': 'criteria',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, match_entity=None, match_field=None, match_type=None, criteria=None, *args, **kwargs):  # noqa: E501
        self.__match_entity = None
        self.__match_field = None
        self.__match_type = None
        self.__criteria = None
        self.discriminator = None
        self.__match_entity = match_entity
        self.__match_field = match_field
        self.__match_type = match_type
        if criteria is not None:
            self.__criteria = criteria
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'microseg.v4.config.MatchingCriteria'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def match_entity(self):
        """
        

        :type:
            :class:`~ntnx_microseg_py_client.models.microseg.v4.config.MatchEntity`
        """  # noqa: E501
        return self.__match_entity

    @match_entity.setter
    def match_entity(self, match_entity):
        if match_entity is None:
            raise ValueError("Invalid value for `match_entity`, must not be `None`")  # noqa: E501

        self.__match_entity = match_entity

    @property
    def match_field(self):
        """
        

        :type:
            :class:`~ntnx_microseg_py_client.models.microseg.v4.config.MatchField`
        """  # noqa: E501
        return self.__match_field

    @match_field.setter
    def match_field(self, match_field):
        if match_field is None:
            raise ValueError("Invalid value for `match_field`, must not be `None`")  # noqa: E501

        self.__match_field = match_field

    @property
    def match_type(self):
        """
        

        :type:
            :class:`~ntnx_microseg_py_client.models.microseg.v4.config.MatchType`
        """  # noqa: E501
        return self.__match_type

    @match_type.setter
    def match_type(self, match_type):
        if match_type is None:
            raise ValueError("Invalid value for `match_type`, must not be `None`")  # noqa: E501

        self.__match_type = match_type

    @property
    def criteria(self):
        """
        The criteria to use for matching entities to be categorized. Note that depending on the match type, the usage of this value may differ.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__criteria

    @criteria.setter
    def criteria(self, criteria):
        if criteria is not None and len(criteria) > 200:
            raise ValueError("Invalid value for `criteria`, length must be less than or equal to `200`")  # noqa: E501

        self.__criteria = criteria

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(MatchingCriteria, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MatchingCriteria):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

