# coding: utf-8


"""
IGNORE:
    Nutanix Flow Management APIs

    Manage Network Security Policy configuration of Nutanix clusters.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path

class PolicyCount(object):

    """Cumulative Policy counts pre and post Flow upgrade to FNS Next-Gen. Contains total count of FNS Next-Gen policies that'll be created post successful upgrade, total count of FNS policies before upgrade and the total count of FNS Next-Gen policies which were system generated as a result of FNS to FNS Next-Gen conversion.<br> 

    :param new_policies_count: (:attr:`new_policies_count`) Number of policies after the upgrade.
    :type new_policies_count: required
    
    
    :param old_policies_count: (:attr:`old_policies_count`) Number of policies before the migration.
    :type old_policies_count: required
    
    
    :param system_defined_policies_count: (:attr:`system_defined_policies_count`) Count of isolation policies that would be generated post upgrade to FNS Next-Gen.
    :type system_defined_policies_count: required
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'new_policies_count': 'int',
        'old_policies_count': 'int',
        'system_defined_policies_count': 'int',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'new_policies_count': 'newPoliciesCount',
        'old_policies_count': 'oldPoliciesCount',
        'system_defined_policies_count': 'systemDefinedPoliciesCount',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, new_policies_count=None, old_policies_count=None, system_defined_policies_count=None, *args, **kwargs):  # noqa: E501
        self.__new_policies_count = None
        self.__old_policies_count = None
        self.__system_defined_policies_count = None
        self.discriminator = None
        self.__new_policies_count = new_policies_count
        self.__old_policies_count = old_policies_count
        self.__system_defined_policies_count = system_defined_policies_count
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'microseg.v4.operation.PolicyCount'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def new_policies_count(self):
        """
        Number of policies after the upgrade.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__new_policies_count

    @new_policies_count.setter
    def new_policies_count(self, new_policies_count):
        if new_policies_count is None:
            raise ValueError("Invalid value for `new_policies_count`, must not be `None`")  # noqa: E501

        self.__new_policies_count = new_policies_count

    @property
    def old_policies_count(self):
        """
        Number of policies before the migration.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__old_policies_count

    @old_policies_count.setter
    def old_policies_count(self, old_policies_count):
        if old_policies_count is None:
            raise ValueError("Invalid value for `old_policies_count`, must not be `None`")  # noqa: E501

        self.__old_policies_count = old_policies_count

    @property
    def system_defined_policies_count(self):
        """
        Count of isolation policies that would be generated post upgrade to FNS Next-Gen.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__system_defined_policies_count

    @system_defined_policies_count.setter
    def system_defined_policies_count(self, system_defined_policies_count):
        if system_defined_policies_count is None:
            raise ValueError("Invalid value for `system_defined_policies_count`, must not be `None`")  # noqa: E501

        self.__system_defined_policies_count = system_defined_policies_count

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(PolicyCount, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PolicyCount):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

